;; Local customizations for font-lock

;; These are all defined automatically by emacs

(add-hook 'c-mode-hook 'turn-on-font-lock)
(add-hook 'c++-c-mode-hook 'turn-on-font-lock)
(add-hook 'c++-mode-hook 'turn-on-font-lock)
(add-hook 'change-log-mode-hook 'turn-on-font-lock)
(add-hook 'compilation-mode-hook 'turn-on-font-lock)
(add-hook 'dired-mode-hook 'turn-on-font-lock)
(add-hook 'emacs-lisp-mode-hook 'turn-on-font-lock)
(add-hook 'TeX-mode-hook 'turn-on-font-lock) ;; auc tex
(add-hook 'shell-mode-hook 'turn-on-font-lock)
;; (add-hook 'bibtex-mode-hook 'turn-on-font-lock)
(add-hook 'fortran-mode-hook 'turn-on-font-lock)
(add-hook 'mail-mode-hook 'turn-on-font-lock)
(add-hook 'makefile-mode-hook 'turn-on-font-lock)
(add-hook 'outline-mode-hook 'turn-on-font-lock)
(add-hook 'ielm-mode-hook 'turn-on-font-lock)

;; Additional modes regexps

;; TeXinfo (Auc-tex version)
(setq texinfo-font-lock-keywords
  (list
   '("^\\(@c\\|@comment\\)[ \t].*" . font-lock-comment-face)	;comments
   "@\\(@\\|[^}\t \n{]+\\)"					;commands
   '("^\\(*.*\\)[\t ]*$" 1 font-lock-function-name-face t)	;menu items
   '("@\\(emph\\|strong\\|b\\|i\\){\\([^}]+\\)" 2 font-lock-comment-face t)
   '("@\\(file\\|kbd\\|key\\){\\([^}]+\\)" 2 font-lock-string-face t)
   '("@\\(samp\\|code\\|var\\){\\([^}]+\\)" 2 font-lock-function-name-face t)
   '("@\\(xref\\|pxref\\){\\([^}]+\\)" 2 font-lock-keyword-face t)
   '("@end *\\([a-zA-Z0-9]+\\)[ \t]*$" 1 font-lock-function-name-face t)
   '("@item \\(.*\\)$" 1 font-lock-function-name-face t)
   ))

(add-hook 'TeXinfo-mode-hook
	  '(lambda () 
	     (make-local-variable 'font-lock-defaults)
	     (setq font-lock-defaults '(texinfo-font-lock-keywords))
	     (turn-on-font-lock)))



;; HTML
(setq html-font-lock-keywords
   '(("<!--[^>]*>" 0 font-lock-comment-face t) ; Comment.
     ("</?\\sw+" . font-lock-type-face)	; Normal tag start.
     (">" . font-lock-type-face)	; Normal tag end.
     ("<\\(/?\\(a\\|form\\|img\\|input\\)\\)\\>" ; Special tag name.
      1 font-lock-function-name-face t)
     ("\\<\\(\\sw+\\)[>=]" 1 font-lock-keyword-face)) ; Tag attribute.
)

(add-hook 'html-helper-mode-hook 
	  '(lambda ()
	     (make-local-variable 'font-lock-defaults)
	     (setq font-lock-defaults '(html-font-lock-keywords t))
	     (turn-on-font-lock)))


;; BBDB
(setq bbdb-font-lock-keywords
      '(("^[^ \t].*$" . font-lock-string-face)
	("^\\s +[^:]+:" . font-lock-reference-face)))

(add-hook 'bbdb-mode-hook 
	  '(lambda ()
	     (make-local-variable 'font-lock-defaults)
	     (setq font-lock-defaults '(bbdb-font-lock-keywords t))
	     (turn-on-font-lock)))

;; nroff
(setq nroff-font-lock-keywords
   '(("^\\.[\\\][\\\"].*$" . font-lock-comment-face)
     ("^\\.so .*$" . font-lock-reference-face)
     ("^\\.[ST]H.*$" . font-lock-function-name-face)
     ("^\\.[A-Za-z12\\\\].*$" . font-lock-keyword-face)
     "\\([\\\][^ ]*\\)" "^\\.[a-zA-Z].*$"))

(add-hook 'nroff-mode-hook 
	  '(lambda ()
	     (make-local-variable 'font-lock-defaults)
	     (setq font-lock-defaults '(nroff-font-lock-keywords t))
	     (turn-on-font-lock)))




